package mercurial.gestorcliente;

// Inclusión de paquetes
import java.util.Vector;
import java.util.Iterator;
import mercurial.gestorarchivos.*;

public class ClienteProgramador extends Usuario
{	
	private IDirectorioAbstracto directorioMain;
	
	public ClienteProgramador()
	{
		// Crea estructura de directorios
		
		Directorio directorioRaiz = new Directorio();
		directorioRaiz.setNombre("raiz");
		
		Directorio directorioA = new Directorio();
		directorioA.setNombre("a");	
		Directorio directorioB = new Directorio();
		directorioB.setNombre("b");
		Directorio directorioC = new Directorio();
		directorioC.setNombre("c");
		
		Fichero fichero1 = new Fichero();
		fichero1.setNombre("p2.c");
		Fichero fichero2 = new Fichero();
		fichero2.setNombre("p4.c");
		
		directorioMain = directorioRaiz;
		// Añade contenido (directorios y archivos) a lista
		directorioRaiz.add(directorioA); 
		
		directorioA.add(directorioB);
	
		directorioB.add(directorioC);
		directorioB.add(fichero1);
		
		directorioC.add(fichero2);
		
	}
	
	// Establecimiento de comandos del programador
	public void setComando(Comando comando)
	{
		// Comandos básicos
		super.setComando(comando); 
		
		if (comando.getComando().equals("delete"))
		{
			try{
				borrarFichero(comando.getParametros().lastElement(), comando.getParametros());
			} catch (Exception ex)
			{
				System.out.println("Fichero no encontrado");	
			}
		}		
	}	
	
	// Añade fichero remoto
	public void anadirFichero(String fichero, Vector<String> pathFichero)
	{
	}

	// Método para borrar un fichero local
	public void borrarFichero(String fichero, Vector<String> pathFichero) throws Exception
	{
		Iterator i = pathFichero.iterator();
		i.next(); // Salta el raíz (siempre debe estar)
		
		while (directorioMain != null && i.hasNext() && !directorioMain.getNombre().equals(fichero))
		{
			System.out.println("Accediendo a: " + directorioMain.getNombre());
			directorioMain = directorioMain.getItem((String)i.next());
		}
			
		// Se ha encontrado el fichero 
		if (directorioMain != null && directorioMain.getNombre().equals(fichero))
			((Fichero)directorioMain).deleteFile(directorioMain.getNombre());
		else throw new Exception(); // Error, no se encuentra fichero
	}
}